(in-package #:cl-astar/tests)


(define-test integer-coordinates-coding
  :parent cl-astar
  (fail (encode-integer-coordinates 0.0 0))
  (fail
   (encode-integer-coordinates 0 (1- (ash 1 a*::+bits-per-coordinate+))))
  (fail
   (encode-integer-coordinates 0 (- (ash 1 a*::+bits-per-coordinate+))))
  (finish
   (encode-integer-coordinates 0 (1- (ash 1 (1- a*::+bits-per-coordinate+)))))
  (finish
   (encode-integer-coordinates 0 (- (ash 1 (1- a*::+bits-per-coordinate+)))))
  (let+ (((&macrolet test-case (x y)
            `(let+ (((&values x* y*) (decode-integer-coordinates
                                      (encode-integer-coordinates ,x ,y))))
               (is = ,x x*)
               (is = ,y y*)))))
    (test-case 0 0)
    (test-case -1 -1)
    (test-case 42 42)
    (test-case -10000 10000)
    (test-case 20000 -20000)
    (test-case #.(1- (ash 1 (1- a*::+bits-per-coordinate+)))
               #.(1- (ash 1 (1- a*::+bits-per-coordinate+))))
    (test-case #.(- (ash 1 (1- a*::+bits-per-coordinate+)))
               #.(- (ash 1 (1- a*::+bits-per-coordinate+))))
    (test-case #.(- (ash 1 (1- a*::+bits-per-coordinate+)))
               #.(1- (ash 1 (1- a*::+bits-per-coordinate+))))
    (test-case #.(1- (ash 1 (1- a*::+bits-per-coordinate+)))
               #.(- (ash 1 (1- a*::+bits-per-coordinate+))))))

(define-test float-coordinates-coding
  :parent cl-astar
  (fail (encode-float-coordinates 1 0))
  (fail (encode-float-coordinates 0.0 most-positive-single-float))
  (fail (encode-float-coordinates 0.0 least-positive-single-float))
  (fail (encode-float-coordinates 0.0 (- most-positive-single-float)))
  (fail (encode-float-coordinates 0.0 (- least-positive-single-float)))
  (let+ (((&macrolet test-case (x y)
            `(let+ (((&values x* y*) (decode-float-coordinates
                                       (encode-float-coordinates ,x ,y))))
               (is = ,x x*)
               (is = ,y y*)))))
    (test-case 0.0 0.0)
    (test-case -1.0 -1.0)
    (test-case 42.0 42.0)
    (test-case -10000.0 10000.0)
    (test-case 20000.0 -20000.0)
    (test-case a*::+most-float-coordinate+
               a*::+most-float-coordinate+)
    (test-case #.(* 1.00001 a*::+least-float-coordinate+)
               #.(* 1.00001 a*::+least-float-coordinate+))
    (test-case a*::+most-float-coordinate+
               #.(* 1.00001 a*::+least-float-coordinate+))
    (test-case #.(* 1.00001 a*::+least-float-coordinate+)
               a*::+most-float-coordinate+)))

(define-test most-negative-fixnum-unreachable-in-coding
  :parent cl-astar
  "It is used as a guard value in CAME-FROM array"
  (let ((max-power-of-two (ash 1 (1- a*::+bits-per-coordinate+))))
    (isnt = most-negative-fixnum (encode-integer-coordinates
                                  (1- max-power-of-two)
                                  (1- max-power-of-two)))
    (isnt = most-negative-fixnum (encode-integer-coordinates
                                  (- max-power-of-two)
                                  (- max-power-of-two)))
    (isnt = most-negative-fixnum (encode-integer-coordinates
                                  (1- max-power-of-two)
                                  (- max-power-of-two)))
    (isnt = most-negative-fixnum (encode-integer-coordinates
                                  (- max-power-of-two)
                                  (1- max-power-of-two)))))
